package com.bocloud.sms.entity;

import com.megatron.entity.annotations.*;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 组织机构管理
 *
 * @author bocloud
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("department")
public class Department extends GenericEntity {

    /**
     * id
     */
    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 父节点id
     */
    @Column("parent_id")
    @IgnoreUpdate
    private Long parentId;
    /**
     * 租户id
     */
    @Column("tenant_id")
    private Long tenantId;
    @Column("origin")
    private String origin;
    @IgnoreAll
    private List<Department> children;
    @IgnoreAll
    private List<User> users;
}
