package com.bocloud.sms.entity;

import com.megatron.entity.annotations.*;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 标签管理
 *
 * @author wangyu
 * @version 3.0.0-SNAPSHOT
 * @since 2018/7/2
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("label")
public class Label extends Generic {
    /**
     * id
     */
    @PK(PKStrategy.AUTO)
    private Long id;
    /**
     * 标签名称
     */
    @Column("name")
    private String name;
    /**
     * 标签内容
     */
    @Column("content")
    private String content;

    /**
     * 创建者id
     */
    @IgnoreUpdate
    @Column("create_id")
    private Long createId;

    /**
     * 所属租户id
     */
    @Column("tenant_id")
    private Long tenantId;

    /**
     * 是否为私有标签
     */
    @Column("personal")
    private Boolean personal;

    /**
     * 标签描述
     */
    @Column("remark")
    private String remark;

    @IgnoreAll
    private List<String> values;

}
