package com.bocloud.sms.model;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * @author tyl
 * @since 2021/3/25 10:17
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class ProjectModel {
    /**
     * 项目名称
     */
    private String name;
    /**
     * 项目编号
     */
    private String code;
    /**
     * 资源操作属性
     */
    private Visibility visibility;
    /**
     * 项目经理id
     */
    private Long managerId;
    /**
     * 所属业务id
     */
    private Long businessId;
    /**
     * 所属租户id
     */
    private Long tenantId;
    /**
     * 项目描述
     */
    private String remark;

    /**
     * 成员id
     */
    private List<Long> userIds;

    /**
     * 平台用户成员id
     */
    private List<Long> managerIds;

    /**
     * 所属组织ID
     */
    private Long departId;
    /**
     * 所属组织ID绝对路径
     */
    private String departIds;

    public enum Visibility {
        /**
         * 可管理
         */
        manageable,
        /**
         * 可见
         */
        visible,
        /**
         * 不可见
         */
        invisible,
    }
}
