package com.bocloud.sms.monitor;

import com.google.common.collect.Lists;
import lombok.Data;

import java.util.List;

/**
 * @author aile
 * @date 2019/12/17 10:52
 */
@Data
public class ComponentModel {

    private String name;
    /**
     * 集群中所有节点都正常时：running，个别节点挂掉但是能运行：warning；不能运行：error
     */
    private String status;
    private List<Component> instance = Lists.newArrayList();

    public ComponentModel(){super();}
    public ComponentModel(String name, String status, List<Component> instance){
        this.name = name;
        this.status = status;
        this.instance = instance;
    }

    @Data
    public static class Component{
        private String host;
        private String status;
        private Long pid;   //预留字段，可能会用到
        private boolean master; //true：主；false：从
        private Object componentInfo;   //组件具体信息，暂时用不到

        public Component(){super();}

        public Component(String host, String status, Long pid, boolean master, Object componentInfo){
            this.host = host;
            this.status = status;
            this.pid = pid;
            this.master = master;
            this.componentInfo = componentInfo;
        }

    }

}
