package com.bocloud.sms.monitor;

import com.alibaba.fastjson.JSONObject;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * prometheus表达式标签匹配参数
 *
 * @author zhangyf
 * @since 2019-12-30
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class LabelParam {
    /**
     * Label
     */
    private String label;
    /**
     * 值
     */
    private String value;
    /**
     * 匹配符
     */
    private Operator operator;

    public LabelParam() {
        this.operator = Operator.EQ;
    }

    public LabelParam(String label, String value) {
        this.label = label;
        this.value = value;
        this.operator = Operator.EQ;
    }

    public LabelParam(String label, String value, Operator operator) {
        this.label = label;
        this.value = value;
        this.operator = operator;
    }

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }
}