package com.bocloud.sms.repository;

import com.bocloud.sms.entity.Label;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.common.utils.ListTool;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.database.utils.QueryBuilder;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Repository("labelRepository")
public class LabelRepository extends BasicGenericDao<Label, Long> {

    public LabelRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    public List<Label> list(int page, int rows, List<Param> params, Map<String, String> sorter, Long tenantId) throws Exception {
        String sql = "select a.* from label a  where 1 = 1 and (tenant_id = 0 or tenant_id = " + tenantId + " ) ";
        sql = getQueryBuilder().build(sql, new Pager(page, rows, params, sorter), "a");
        Map<String, Object> param = getQueryBuilder().getParam(params);
        param.put("tenantId", tenantId);
        return this.list(Label.class, sql, param);
    }

    public List<Label> list(List<Param> params, Long tenantId) throws Exception {
        String sql = "select a.* from label a  where 1 = 1 and (tenant_id = 0 or tenant_id = " + tenantId + " ) ";
        sql = getQueryBuilder().build(sql, new Pager(1, Integer.MAX_VALUE, params, new HashMap<>(8)), "a");
        Map<String, Object> param = getQueryBuilder().getParam(params);
        param.put("tenantId", tenantId);
        return this.list(Label.class, sql, param);
    }

    public int count(List<Param> params, Long tenantId) throws Exception {
        String sql = "select count(1) from label where 1 = 1 and (tenant_id = 0 or tenant_id = " + tenantId + ")";
        sql = getQueryBuilder().build(sql, params, new HashMap<>(8), "");
        Map<String, Object> param = getQueryBuilder().getParam(params);
        param.put("tenantId", tenantId);
        return this.countQuery(sql, param).intValue();
    }

    public boolean remove(Long id) throws Exception {
        String sql = "delete from label where id = :id ";
        Map<String, Object> params = MapTools.simpleMap("id", id);
        return this.execute(sql, params) > 0;
    }

    public Label query(Long id) throws Exception {
        String sql = "select * from label where id = :id";
        Map<String, Object> paramMap = MapTools.simpleMap("id", id);
        List<Label> labels = this.list(Label.class, sql, paramMap);
        return ListTool.isEmpty(labels) ? null : labels.get(0);
    }

    public Label query(String name) throws Exception {
        String sql = "select * from label where name = :name";
        Map<String, Object> paramMap = MapTools.simpleMap("name", name);
        List<Label> labels = this.list(Label.class, sql, paramMap);
        return ListTool.isEmpty(labels) ? null : labels.get(0);
    }

    public boolean exists(String name) throws Exception {
        String sql = "select * from label where name = :name";
        Map<String, Object> paramMap = MapTools.simpleMap("name", name);
        List<Label> labels = this.list(Label.class, sql, paramMap);
        if (ListTool.isEmpty(labels)) {
            return false;
        }
        return true;
    }


}
