package com.bocloud.sms.repository;

import com.bocloud.sms.entity.PortalPanel;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.framework.core.CurrentService;
import com.mysql.cj.util.StringUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * @author lyy
 */
@Repository
public class PortalPanelRepository extends BasicGenericDao<PortalPanel, Long> {

    public PortalPanelRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    public List<PortalPanel> listPortalPanel(String module) {
        String sql = "select * from portal_panel where is_deleted = 0 ";
        if (!StringUtils.isNullOrEmpty(module)) {
            sql += " and module = '" + module + "' ";
        }
        return this.list(PortalPanel.class, sql);
    }

    public Boolean remove(Long id) {
        String sql = "update portal_panel set is_deleted = 1 where id = :id and is_deleted = 0";
        Map<String, Object> params = MapTools.simpleMap("id", id);
        return this.execute(sql, params) > 0;
    }

    public Boolean removeByModule(String module, Long userId) {
        String sql = "update portal_panel set is_deleted = 1,mender_id=:userId where module = :module and is_deleted = 0";
        Map<String, Object> params = MapTools.simpleMap("module", module);
        params.put("userId", userId);
        return this.execute(sql, params) > 0;
    }

    public List<PortalPanel> queryDefaultByModule(String module) {
        String sql = "select * from portal_panel_default where module = :module";
        Map<String, Object> params = MapTools.simpleMap("module", module);
        return this.list(PortalPanel.class, sql, params);
    }

    public List<PortalPanel> listPortalPanelCop(String module, Long userId) {
        String sql = "select * from portal_panel where is_deleted = 0 ";
        if (!StringUtils.isNullOrEmpty(module)) {
            sql += " and module = '" + module + "' ";
        }
        if(null != userId && 0!=userId){
            sql += " and creator_id = " + userId ;
        }
        return this.list(PortalPanel.class, sql);
    }

    public Boolean removeByModuleCop(String module, Long userId) {
        String sql = "update portal_panel set is_deleted = 1,mender_id=:userId where module = :module and is_deleted = 0 and creator_id=:userId";
        Map<String, Object> params = MapTools.simpleMap("module", module);
        params.put("userId", userId);
        return this.execute(sql, params) > 0;
    }

}
