package com.bocloud.sms.repository;


import com.bocloud.sms.entity.SystemNotice;
import com.megatron.common.exception.DataBaseException;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.common.utils.ListTool;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.database.utils.QueryBuilder;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Repository("SystemNoticeRepository")
public class SystemNoticeRepository extends BasicGenericDao<SystemNotice, Long> {
    public SystemNoticeRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }


    public List<SystemNotice> list(int page, int rows, List<Param> params, Map<String, String> sorter) throws DataBaseException {
        String sql = "select * from system_notice a where is_deleted = 0  ";
        sql = getQueryBuilder().buildRaw(sql, new Pager(page, rows, params, sorter), "a");
        Map<String, Object> param = getQueryBuilder().getParam(params);
        return this.list(SystemNotice.class, sql, param);
    }

    public List<SystemNotice> list(List<Param> params) throws DataBaseException {
        String sql = "select * from system_notice a where is_deleted = 0  ";
        sql = getQueryBuilder().buildRaw(sql, new Pager(1, Integer.MAX_VALUE, params, new HashMap<>(8)), "a");
        Map<String, Object> param = getQueryBuilder().getParam(params);
        return this.list(SystemNotice.class, sql, param);
    }

    public int count(List<Param> params) throws DataBaseException {
        String sql = "select count(1) from system_notice where is_deleted = 0  ";
        sql = getQueryBuilder().build(sql, params, new HashMap<>(8), "");
        Map<String, Object> param = getQueryBuilder().getParam(params);
        return this.countQuery(sql, param).intValue();
    }


    public SystemNotice query(Long id) throws Exception {
        String sql = "select * from system_notice where is_deleted = 0 and id = :id";
        Map<String, Object> paramMap = MapTools.simpleMap("id", id);
        List<SystemNotice> entitys = this.list(SystemNotice.class, sql, paramMap);
        return ListTool.isEmpty(entitys) ? null : entitys.get(0);
    }


}
