package com.bocloud.sms.utils;

/**
 * 数据库关键字处理工具类
 *
 * @author zhangyf
 * @since 2022-02-28
 */
public class DBKeywordUtil {

    /**
     * DM数据库转义字符
     */
    private static final char ESCAPE_KEY_DM = '\"';
    private static final char ESCAPE_KEY_MYSQL = '`';

    /**
     * 关键字加上转义字符
     *
     * @param key
     * @param dialect
     * @return
     */
    public static String warp(String key, String dialect) {
        if ("dm".equalsIgnoreCase(dialect)) {
            return ESCAPE_KEY_DM + key + ESCAPE_KEY_DM;
        }
        if ("mysql".equalsIgnoreCase(dialect)) {
            return ESCAPE_KEY_MYSQL + key + ESCAPE_KEY_MYSQL;
        }
        return key;
    }

}
